(function ($, window, document) {
    var emailID;
    $.fn.extend({
        addCombinedModal: function (appData, callback) {
            $(document).ready(function () {
                var usrData;
                var usrPii;
                var cookiesData;
                var pInfoData;
                var appEnv = '';
                var combinedToken;
                var appInfo;
                var userTerms;
                var windowWidth = $(window).width();

                switch (appData.environment) {
                    case 'dev':
                        appEnv = 'https://privacyapi-dev.freeman.com/api';
                        break;
                    case 'test':
                        appEnv = 'https://privacyapi-test.freeman.com/api';
                        break;
                    case 'uat':
                        appEnv = 'https://privacyapi-uat.freeman.com/api';
                        break;
                    case 'prod':
                        appEnv = 'https://privacyapi.freeman.com/api';
                        break;
                }

                // Set up request header with ApiKey for Security
                $.ajaxSetup({
                    headers: {
                        'X-ApiKey': appData.apiKey
                    }
                });

                $(this).getToken(appData, appEnv, function (returnToken) {
                    combinedToken = returnToken;
                });

                function onContinueClick(cookiedata, piidata, appinfo) {
                    if (!($('#continueButton').hasClass("disabled"))) {
                        // Save Cookie Consent
                        var cookieCellData = [];
                        var finalCookieData = [];
                        var MarketingCheckboxValue = $('#promotionsChkbox').is(":checked");
                        var cookieRowData = $('#cookieModalBody').find('tr').map(function () {
                            return $(this);
                        }).get();

                        for (var i = 0; i < cookieRowData.length; i++) {
                            var eachCookieCellData = cookieRowData[i].find('td').map(function () {
                                return $(this).text();
                            }).get();
                            cookieCellData.push(eachCookieCellData);

                            cookieCellData[i][4] = $('#cookieCheckbox-' + (i)).is(":checked");

                            var cookieSource = cookieCellData[i];
                            var cookieObj = cookieSource.reduce(function (o, val, i) {
                                o[i] = val;
                                return o;
                            }, {});
                            if (cookieObj.hasOwnProperty(0)) {
                                cookieObj["CookieName"] = cookiedata[i][0]['Name'];
                                delete cookieObj[0];
                            }
                            if (cookieObj.hasOwnProperty(1)) {
                                delete cookieObj[1];
                            }
                            if (cookieObj.hasOwnProperty(2)) {
                                delete cookieObj[2];
                            }
                            if (cookieObj.hasOwnProperty(3)) {
                                delete cookieObj[3];
                            }
                            if (cookieObj.hasOwnProperty(4)) {
                                cookieObj["IsConsent"] = cookieObj[4];
                                delete cookieObj[4];
                            }
                            cookieObj["CookieConsentId"] = i;
                            finalCookieData.push(cookieObj);
                        }

                        var cookieConsentObject = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "UserCookies": finalCookieData
                        };

                        // save Privacy Consent
                        var privacyCellData = [];
                        var finalPrivacyCellData = [];
                        var privacyRowData = $('#privacyModalBody').find('tr').map(function () {
                            return $(this);
                        }).get();

                        for (var j = 0; j < privacyRowData.length; j++) {
                            var eachPrivacyCellData = privacyRowData[j].find('td').map(function () {
                                return $(this).text();
                            }).get();
                            privacyCellData.push(eachPrivacyCellData);

                            privacyCellData[j][3] = $('#privacyCheckbox-' + (j)).is(":checked");

                            var privacySource = privacyCellData[j];
                            var privacyObj = privacySource.reduce(function (o, val, j) {
                                o[j] = val;
                                return o;
                            }, {});
                            if (privacyObj.hasOwnProperty(0)) {
                                privacyObj["PIIField"] = piidata[j]['FieldName'];
                                delete privacyObj[0];
                            }
                            if (privacyObj.hasOwnProperty(1)) {
                                delete privacyObj[1];
                            }
                            if (privacyObj.hasOwnProperty(2)) {
                                delete privacyObj[2];
                            }
                            if (privacyObj.hasOwnProperty(3)) {
                                privacyObj["PIIConsentState"] = privacyObj[3] ? "Confirmed" : "Denied";
                                delete privacyObj[3];
                            }
                            privacyObj['PIIConsentId'] = j;
                            finalPrivacyCellData.push(privacyObj);
                        }

                        var privacyConsentObject = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "UserPIIFields": finalPrivacyCellData
                        };

                        var userTermsConsent = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "IsConsent": true
                        };

                        var marketingConsent = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "IsConsent": MarketingCheckboxValue
                        };

                        // Send Cookie Consent
                        $.post(appEnv + "/cookieconsent/save", cookieConsentObject, function (data, status, xhr) {
                            // Send Privacy Consent
                            $.post(appEnv + "/piiconsent/save", privacyConsentObject, function (data, status, xhr) {
                                // Save User terms consent
                                $.post(appEnv + "/termsofuse/save", userTermsConsent, function (data, status, xhr) {
                                    // Save Marketing consent
                                    if (appinfo.IsMarketingData == true) {
                                        $.post(appEnv + "/marketing/save", marketingConsent, function (data, status, xhr) {

                                        });
                                    }
                                    $('#combinedModal').modal('hide');
                                });
                            });
                        });

                        var returnConsent = {
                            "Username": appData['userName'],
                            "Application": appData['appName'],
                            "UserCookies": finalCookieData,
                            "UserPIIFields": finalPrivacyCellData,
                            "Token": combinedToken,
                            "UserTermsConsent": true,
                            "UserMarketingConsent": appinfo.IsMarketingData == true ? MarketingCheckboxValue : false
                        };

                        callback(returnConsent);
                    }
                }

                var combinedStyles = "";
                combinedStyles += ".btn.disabled { cursor: not-allowed }";
                combinedStyles += ".mobileImage { width: 130px; }";
                combinedStyles += ".gdpr-card-anchor{ font-size: 15px; color: black }";
                combinedStyles += ".gdpr-card-anchor:hover {color: black }";
                combinedStyles += ".gdpr-card-anchor:active {color: black }";
                combinedStyles += ".gdpr-card-anchor:focus {color: black }";
                combinedStyles += ".modalSize { @media only screen and  (max-width: 900px) { width: 600px; } }";
                combinedStyles += ".consentCheckbox { display: inline !important; transform: scale(1.2) }";
                combinedStyles += ".overflowStyle { overflow-x: hidden; overflow-y: auto }";
                combinedStyles += ".policyText { font-weight: bold } ";
                combinedStyles += ".categoryText { font-size: 13px; font-style: italic; }";
                combinedStyles += ".categoryTextWeb { font-size: 15px; font-weight: 500; }";
                combinedStyles += ".consentAnchor {color: #ff9933; cursor: pointer; font-size: 15px; }";
                combinedStyles += ".consentTableWeb { height: 350px; overflow: auto; }";
                combinedStyles += ".consentTable { height: 250px; overflow: auto; }";
                combinedStyles += ".switch { position: relative; display: inline-block; width: 60px; height: 34px; } ";
                combinedStyles += ".switch input { display: none }";
                combinedStyles += ".slider { position: absolute; cursor: pointer; top: 1px; left: 2px; right: 0; bottom: 0; border-radius: 16px; background-color: #fff; border: 1px solid #d9d9d9; -webkit-transition: all 0.3s; transition: all 0.3s;}";
                combinedStyles += ".slider::before { position: absolute; content: ''; display: 'block'; left: -2px; top: 1px; width: 30px; height: 30px; border-radius: 16px; background-color: #fff; border: 1px solid #d9d9d9; -webkit-transition: all 0.3s; transition: all 0.3s;}";
                combinedStyles += "input[type=checkbox]:checked + .slider { background-color: #55D069 }";
                combinedStyles += "input:focus + .slider { box-shadow: 0 0 1px #2196F3 }";
                combinedStyles += "input[type=checkbox]:checked + .slider:before { -webkit-transform: translateX(26px); -ms-transform: translateX(26px); transform: translateX(26px); }";
                combinedStyles += ".slider.round { border-radius: 34px }";
                combinedStyles += ".slider.round::before { box-shadow: 0 0 5px rgba(0,0,0,0.3); border-radius: 50%; }";
                combinedStyles += ".slider.round.disabledColor { background-color: #acadae !important; cursor: not-allowed }";
                combinedStyles += ".checkBox-disabled { pointer-events: none; }"
                combinedStyles += ".combinedModalTitle {    font-size: 22px; text-align: right; margin-top: 30px; float: right;}";
                combinedStyles += ".border-right { border-right: 1px solid; }";
                combinedStyles += ".container-border { border: 1px solid #d1d1d1; }";
                combinedStyles += ".offspan {   padding-left: 32px; font-size: 13px; padding-top: 5px; color: #acadae;}";
                // combinedStyles += ".offspan.slider::before { position: absolute; content: ''; height: 20px; width: 20px; left: 4px; bottom: 4px; background-color: #acadae !important; -webkit-transition: .4s; transition: .4s;}";
                combinedStyles += ".bg-white { background-color: #ffffff; !important}";
                combinedStyles += ".onSpan {    padding-left: 5px; font-size: 13px; padding-top: 5px; color: white;}";
                combinedStyles += ".cookie-Name { font-size: 19px; color: #b4b4b4; font-weight: bold;}";
                combinedStyles += ".font-15 { font-size: 15px; font-weight: 500; }";
                combinedStyles += ".font-13 { font-size: 13px; font-weight: 500; }";
                combinedStyles += ".tableheaderColor { color: #8a8b8c; }";
                combinedStyles += ".consentDescription { color: #acadae; }";
                combinedStyles += ".heading { color: #4a4a4a; }";
                combinedStyles += ".mar-right-5 { margin-right: 5px; }";
                combinedStyles += ".mar-bottom-15 { margin-bottom: 15px; }";
                combinedStyles += ".mar-bottom-0 { margin-bottom: 0px; }";
                combinedStyles += ".pad-left-0 { padding-left: 0; }";
                combinedStyles += ".bg-disabled { background-color: #acadae; color: #FFFF;: left; }";
                combinedStyles += ".btn-primary-color { color: #fff; background-color: #0066b3 !important; border-color: #0066b3 !important;";
                combinedStyles = "<style>" + combinedStyles + "</style>";

                var getUserCookies = appEnv + "/cookieconsent/APP_NAME/USER_NAME/EMAIL"
                    .replace(/APP_NAME/g, appData['appName'])
                    .replace(/USER_NAME/g, appData['userName'])
                    .replace(/EMAIL/g, appData['email']);

                var getUserPii = appEnv + "/piiconsent/APP_NAME/USER_NAME/EMAIL"
                    .replace(/APP_NAME/g, appData['appName'])
                    .replace(/USER_NAME/g, appData['userName'])
                    .replace(/EMAIL/, appData['email']);

                var getAppInfo = appEnv + "/application/APP_NAME"
                    .replace(/APP_NAME/g, appData['appName']);

                var getUserTerms = appEnv + "/termsofuse/APP_NAME/USER_NAME/EMAIL"
                    .replace(/APP_NAME/g, appData['appName'])
                    .replace(/USER_NAME/g, appData['userName'])
                    .replace(/EMAIL/, appData['email']);

                var getMarketingData = appEnv + "/marketing/APP_NAME/USER_NAME"
                    .replace(/APP_NAME/g, appData['appName'])
                    .replace(/USER_NAME/g, appData['userName']);

                $.get(getAppInfo, function (appinfo) {
                    appInfo = appinfo;
                    $.get(getUserTerms, function (terms) {
                        userTerms = terms;
                        $.get(getUserCookies, function (cookies) {
                            usrData = cookies;
                            $.get(getUserPii, function (data) {
                                usrPii = data;

                                if (usrData['IsShow'] === true || usrPii['IsShow'] == true) {
                                    var combinedModal = document.createElement('div');
                                    combinedModal.className = "modal fade overflowStyle";
                                    combinedModal.id = "combinedModal";
                                    combinedModal.tabIndex = "-1";
                                    combinedModal.setAttribute("role", "dialog");
                                    combinedModal.setAttribute("aria-labelledby", "combinedModal");
                                    combinedModal.setAttribute("aria-hidden", "true");
                                    combinedModal.setAttribute("data-backdrop", "static");

                                    var modalDialog = document.createElement('div');
                                    modalDialog.className = "modal-dialog modal-lg  modalSize";
                                    modalDialog.setAttribute("role", "document");

                                    var modalContent = document.createElement('div');
                                    modalContent.className = "modal-content";

                                    var modalHeader = document.createElement('div');
                                    modalHeader.className = "modal-header";

                                    var header = document.createElement('h5');
                                    header.className = "modal-title policyText col-md-12 col-sm-12 combinedModalTitle";
                                    header.id = "combinedModalHeader";
                                    header.innerHTML = "Privacy Settings";

                                    var modalImage = document.createElement('img');
                                    modalHeader.appendChild(modalImage);

                                    modalHeader.appendChild(header);

                                    var termsRow = document.createElement('div');
                                    if (appInfo.BrandingImageType != null && appInfo.BrandingImageBLOB != "") {
                                        modalImage.className = "col-md-2 border-right mobileImage";
                                        header.className = "modal-title policyText col-md-10 col-sm-8 combinedModalTitle";
                                        modalImage.setAttribute("src", appInfo.BrandingImageType + "," + appInfo.BrandingImageBLOB);
                                    }

                                    var modalBody = document.createElement('div');
                                    modalBody.className = "modal-body";

                                    var promotionsCheckbox = document.createElement('input');
                                    var promotionsCheckboxChkboxLabel = document.createElement('label');

                                    if (windowWidth >= 1024) {
                                        var continueButton = document.createElement('button');

                                        // Cookie Policy Table Start

                                        var cookieHeading = document.createElement('h3');
                                        cookieHeading.className = "heading";
                                        cookieHeading.innerText = "Cookies";

                                        modalBody.appendChild(cookieHeading);

                                        var cookieContent = document.createElement('div');
                                        cookieContent.className = "tab-content";

                                        //  Cookie policy tab and table
                                        var divCookie = document.createElement('div');
                                        divCookie.id = "pills-CookiePolicy";

                                        var cookieContainer = document.createElement('div');
                                        cookieContainer.className = "container";

                                        var cookieRow = document.createElement('div');
                                        cookieRow.className = "row";

                                        var rowHeader = document.createElement('h6');
                                        rowHeader.className = "policyText consentDescription";
                                        rowHeader.innerHTML = "Our website uses cookies and other technologies so that we can remember you and understand how you and other visitors use our site.\n" +
                                            "We want you to have control over the information we collect, please confirm your cookie preferences and review our \n";

                                        var anotherDiv = document.createElement('div');
                                        anotherDiv.id = "gdpr-cookieChange";
                                        var cookieBothChange = document.createElement('p');
                                        cookieBothChange.id = 'cookieBothChange';
                                        cookieBothChange.className = 'consentDescription';
                                        cookieBothChange.innerHTML = "Our policy has been updated. See yellow highlights for changes.";
                                        $(cookieBothChange).css({
                                            fontWeight: 'bold',
                                            display: 'none',
                                            fontStyle: 'italic'
                                        });
                                        anotherDiv.appendChild(cookieBothChange);

                                        if (appInfo['IsReconsent'] == true) {
                                            var cookieChange = document.createElement('p');
                                            cookieChange.id = 'cookieChange';
                                            cookieChange.className = 'consentDescription';
                                            cookieChange.appendChild(document.createElement('br'));
                                            cookieChange.innerHTML = "Our policy has been updated. Please review and re-consent.";
                                            $(cookieChange).css({
                                                fontWeight: 'bold',
                                                fontStyle: 'italic'
                                            });
                                            anotherDiv.appendChild(cookieChange);
                                        }

                                        var CPolicy = document.createElement('a');
                                        CPolicy.id = "aSpan";
                                        CPolicy.setAttribute("href", appInfo['CookiePolicyURL']);
                                        CPolicy.setAttribute("target", "_blank");
                                        CPolicy.innerHTML = "Cookie Policy.";
                                        CPolicy.className = "consentAnchor";

                                        rowHeader.appendChild(CPolicy);

                                        anotherDiv.appendChild(rowHeader);

                                        var cookieTabRow = document.createElement('div');
                                        cookieTabRow.className = "row consentTableWeb container-border";
                                        cookieTabRow.id = "cookieTabDiv";

                                        var cookieTable = document.createElement('table');
                                        cookieTable.id = "cookieTable";
                                        cookieTable.className = "table";

                                        var cookieHead = document.createElement('thead');

                                        var cookieTableRow = document.createElement('tr');

                                        var cookieCellFragment = document.createDocumentFragment();
                                        var cookieTableHeaders = ['Cookie', 'Purpose', 'Consent'];

                                        cookieTableHeaders.forEach(function (header) {
                                            var cell = document.createElement('th');
                                            cell.textContent = header;
                                            cell.className = "tableheaderColor";
                                            cookieCellFragment.appendChild(cell);
                                        });

                                        var cookieModalBody = document.createElement('tbody');
                                        cookieModalBody.id = "cookieModalBody";

                                        cookieTableRow.appendChild(cookieCellFragment);
                                        cookieHead.appendChild(cookieTableRow);
                                        cookieTable.appendChild(cookieHead);
                                        cookieTable.appendChild(cookieModalBody);
                                        cookieTabRow.appendChild(cookieTable);
                                        cookieRow.appendChild(rowHeader);
                                        cookieRow.appendChild(anotherDiv);
                                        cookieContainer.appendChild(cookieRow);
                                        cookieContainer.appendChild(cookieTabRow);
                                        divCookie.appendChild(cookieContainer);

                                        cookieContent.appendChild(divCookie);
                                        modalBody.appendChild(cookieContent);
                                        var breakLine = document.createElement('br');
                                        modalBody.appendChild(breakLine);


                                        var cookieCosentCheckbox = document.createElement('input');
                                        var cookieCosentCheckboxLabel = document.createElement('label');
                                        var cookieCosentlabeltext = document.createElement('span');
                                        cookieCosentlabeltext.innerText = "I have read and agreed to the ";
                                        var cookieCosentlabeltext2 = document.createElement('span');
                                        cookieCosentlabeltext2.innerText = " and I have completed my consent selections.";

                                        var CookiePolicy = document.createElement('a');
                                        CookiePolicy.id = "aSpan";
                                        CookiePolicy.setAttribute("href", appInfo['CookiePolicyURL']);
                                        CookiePolicy.setAttribute("target", "_blank");
                                        CookiePolicy.innerHTML = "cookie policy";
                                        CookiePolicy.className = "consentAnchor";
                                        cookieCosentCheckbox.type = "checkbox";
                                        cookieCosentCheckbox.name = "cookie";
                                        cookieCosentCheckbox.className = "mar-right-5 consentCheckbox";
                                        cookieCosentCheckbox.style.display = "inline";
                                        cookieCosentCheckbox.id = "cookieCheckbox";
                                        cookieCosentCheckbox.onclick = function () {
                                            if ($('#cookieCheckbox').is(":checked") && $('#privacyChkbox').is(":checked") && $('#termsChkbox').is(":checked")) {
                                                continueButton.className = "btn btn-primary btn-primary-color";
                                            } else {
                                                continueButton.className = "btn disabled bg-disabled";
                                            }
                                        };


                                        cookieCosentCheckboxLabel.appendChild(cookieCosentCheckbox);


                                        cookieCosentCheckboxLabel.appendChild(cookieCosentlabeltext);
                                        cookieCosentCheckboxLabel.appendChild(CookiePolicy);
                                        cookieCosentCheckboxLabel.appendChild(cookieCosentlabeltext2);

                                        modalBody.appendChild(cookieCosentCheckboxLabel);

                                        // Cookie Policy Table Ends


                                        // PII Policy table Start

                                        var privacyHeading = document.createElement('h3');
                                        privacyHeading.className = "heading";
                                        privacyHeading.innerText = "Personal Data";

                                        modalBody.appendChild(privacyHeading);

                                        var privacyContent = document.createElement('div');
                                        privacyContent.className = "tab-content";

                                        var divPrivacy = document.createElement('div');
                                        divPrivacy.id = "pills-CookiePolicy";

                                        var privacyContainer = document.createElement('div');
                                        privacyContainer.className = "container";

                                        var privacyRow = document.createElement('div');
                                        privacyRow.className = "row";

                                        var rowPrivacyHeader = document.createElement('h6');
                                        rowPrivacyHeader.className = "policyText consentDescription";
                                        rowPrivacyHeader.innerHTML = "At various times Freeman or its agents may collect personally identifiable information.  Freeman will use your personally identifiable information to perform the services you have contracted from us, where necessary for our legitimate interests (that are not overridden by your fundamental rights), to comply with a legal or regulatory obligation and as further detailed in each Freeman application.  For more specifics on our data handling, please review our\n";

                                        var PrivacyPolicy = document.createElement('a');
                                        PrivacyPolicy.id = "aSpan";
                                        PrivacyPolicy.setAttribute("href", appInfo['PrivacyPolicyURL']);
                                        PrivacyPolicy.setAttribute("target", "_blank");
                                        PrivacyPolicy.innerHTML = "Privacy Policy.";
                                        PrivacyPolicy.className = "consentAnchor";

                                        rowPrivacyHeader.appendChild(PrivacyPolicy);
                                        var pTag = document.createElement('p');
                                        pTag.className = "policyText consentDescription";
                                        pTag.innerHTML = "We want you to control the information we collect, so please indicate your approval for us to collect the below information:";

                                        var privacyChangeDiv = document.createElement('div');
                                        privacyChangeDiv.id = "gdpr-privacyChange";
                                        privacyChangeDiv.className = "row";
                                        var privacyBothChange = document.createElement('p');
                                        privacyBothChange.id = 'privacyBothChange';
                                        privacyBothChange.className = 'consentDescription';
                                        privacyBothChange.innerHTML = "Our policy has been updated. See yellow highlights for changes.";
                                        $(privacyBothChange).css({
                                            fontWeight: 'bold',
                                            display: 'none',
                                            fontStyle: 'italic'
                                        });
                                        privacyChangeDiv.appendChild(privacyBothChange);
                                        if (appInfo['IsReconsent'] == true) {
                                            var privacyChange = document.createElement('p');
                                            privacyChange.id = 'privacyChange';
                                            privacyChange.className = 'consentDescription';
                                            privacyChange.innerHTML = "Our policy has been updated. Please review and re-consent.";
                                            $(privacyChange).css({
                                                fontWeight: 'bold',
                                                fontStyle: 'italic'
                                            });

                                            privacyChangeDiv.appendChild(privacyChange);
                                        }

                                        var privacyTabRow = document.createElement('div');
                                        privacyTabRow.className = "row consentTableWeb container-border";
                                        privacyTabRow.id = "cookieTabDiv";

                                        privacyTabRow.appendChild(document.createElement('br'));

                                        var privacyTable = document.createElement('table');
                                        privacyTable.id = "cookieTable";
                                        privacyTable.className = "table";

                                        var privacyHead = document.createElement('thead');

                                        var privacyTableRow = document.createElement('tr');

                                        var cookieCellFragment = document.createDocumentFragment();
                                        var privacyTableHeaders = ['Name', 'How we use this data', 'Consent'];

                                        privacyTableHeaders.forEach(function (header) {
                                            var cell = document.createElement('th');
                                            cell.textContent = header;
                                            cell.className = "tableheaderColor";
                                            cookieCellFragment.appendChild(cell);
                                        });

                                        var privacyModalBody = document.createElement('tbody');
                                        privacyModalBody.id = "privacyModalBody";

                                        privacyTableRow.appendChild(cookieCellFragment);
                                        privacyHead.appendChild(privacyTableRow);
                                        privacyTable.appendChild(privacyHead);
                                        privacyTable.appendChild(privacyModalBody);
                                        privacyTabRow.appendChild(privacyTable);
                                        privacyRow.appendChild(rowPrivacyHeader);
                                        privacyRow.appendChild(pTag);
                                        privacyContainer.appendChild(privacyRow);
                                        privacyContainer.appendChild(privacyChangeDiv);
                                        privacyContainer.appendChild(privacyTabRow);
                                        divPrivacy.appendChild(privacyContainer);

                                        privacyContent.appendChild(divPrivacy);
                                        modalBody.appendChild(privacyContent);

                                        modalBody.appendChild(document.createElement('br'));

                                        var privacyCosentCheckbox = document.createElement('input');
                                        var privacyCosentCheckboxLabel = document.createElement('label');
                                        var privacyCosentlabeltext = document.createElement('span');
                                        privacyCosentlabeltext.innerText = "I have read and agreed to the ";
                                        var privacyCosentlabeltext2 = document.createElement('span');

                                        var privacyCosentlabeltext2 = document.createElement('span');
                                        privacyCosentlabeltext2.innerText = " and I have completed my consent selections.";

                                        var privacyPolicy = document.createElement('a');
                                        privacyPolicy.id = "aSpan";
                                        privacyPolicy.setAttribute("href", appInfo['PrivacyPolicyURL']);
                                        privacyPolicy.setAttribute("target", "_blank");
                                        privacyPolicy.innerHTML = "privacy policy";
                                        privacyPolicy.className = "consentAnchor";
                                        privacyCosentCheckbox.type = "checkbox";
                                        privacyCosentCheckbox.name = "privacy";
                                        privacyCosentCheckbox.className = "mar-right-5 consentCheckbox";
                                        privacyCosentCheckbox.style.display = "inline";
                                        privacyCosentCheckbox.id = "privacyChkbox";
                                        privacyCosentCheckbox.onclick = function () {
                                            if ($('#cookieCheckbox').is(":checked") && $('#privacyChkbox').is(":checked") && $('#termsChkbox').is(":checked")) {
                                                continueButton.className = "btn btn-primary btn-primary-color";
                                            } else {
                                                continueButton.className = "btn disabled bg-disabled";
                                            }
                                        };


                                        privacyCosentCheckboxLabel.appendChild(privacyCosentCheckbox);


                                        privacyCosentCheckboxLabel.appendChild(privacyCosentlabeltext);
                                        privacyCosentCheckboxLabel.appendChild(privacyPolicy);
                                        privacyCosentCheckboxLabel.appendChild(privacyCosentlabeltext2);

                                        modalBody.appendChild(privacyCosentCheckboxLabel);

                                        // PII Policy table End


                                        //Terms and Conditions div Start

                                        var termsCosentCheckbox = document.createElement('input');
                                        var termsCosentCheckboxLabel = document.createElement('label');
                                        var termsCosentlabeltext = document.createElement('span');
                                        termsCosentlabeltext.innerText = "I have read and agreed to the ";

                                        var termsPolicy = document.createElement('a');
                                        termsPolicy.id = "aSpan";
                                        termsPolicy.setAttribute("href", appInfo['TermsConditionsURL']);
                                        termsPolicy.setAttribute("target", "_blank");
                                        termsPolicy.innerHTML = "terms of use.";
                                        termsPolicy.className = "consentAnchor";
                                        termsCosentCheckbox.type = "checkbox";
                                        termsCosentCheckbox.name = "terms";
                                        termsCosentCheckbox.className = "mar-right-5 consentCheckbox";
                                        termsCosentCheckbox.style.display = "inline";
                                        termsCosentCheckbox.id = "termsChkbox";
                                        termsCosentCheckbox.onclick = function () {
                                            if ($('#cookieCheckbox').is(":checked") && $('#privacyChkbox').is(":checked") && $('#termsChkbox').is(":checked")) {
                                                continueButton.className = "btn btn-primary btn-primary-color";
                                            } else {
                                                continueButton.className = "btn disabled bg-disabled";
                                            }
                                        };

                                        termsCosentCheckboxLabel.className = "mar-bottom-15";
                                        termsCosentCheckboxLabel.appendChild(termsCosentCheckbox);


                                        termsCosentCheckboxLabel.appendChild(termsCosentlabeltext);
                                        termsCosentCheckboxLabel.appendChild(termsPolicy);

                                        //Terms and Conditions div Ends

                                        var modalFooter = document.createElement('div');
                                        modalFooter.className = "modal-footer";

                                        var footerContainer = document.createElement('div');
                                        footerContainer.className = "container pad-left-0";

                                        var btnRow1 = document.createElement('div');
                                        btnRow1.className = "row";


                                        var column1 = document.createElement("div");
                                        column1.className = "col-8 col-md-10";

                                        var column2 = document.createElement('div');
                                        column2.className = "col-4 col-md-2";


                                        continueButton.id = "continueButton";
                                        continueButton.type = "button";
                                        continueButton.innerHTML = "Continue";
                                        continueButton.className = "btn disabled bg-disabled";
                                        continueButton.setAttribute("data-title", "Please consent to the cookie policy, privacy poilcy and agree to Terms of use to continue");
                                        continueButton.addEventListener('click', function (element) {
                                            onContinueClick(cookiesData, pInfoData, appinfo);
                                        });

                                        column2.appendChild(continueButton);
                                        btnRow1.appendChild(column1);
                                        btnRow1.appendChild(column2);

                                        footerContainer.appendChild(termsCosentCheckboxLabel);
                                        footerContainer.appendChild(promotionsCheckboxChkboxLabel);
                                        footerContainer.appendChild(btnRow1);
                                        modalFooter.appendChild(footerContainer);
                                    } else {
                                        var continueButton = document.createElement('button');
                                        // Create Accordions
                                        var accordionGroup = document.createElement('div');

                                        var accordionFragments = document.createDocumentFragment();
                                        var accordion = document.createElement('div');
                                        accordion.id = 'accordion';
                                        accordion.style.width = '100%';
                                        var accordions = ['Cookies', 'Personal Data', 'Terms of Use'];
                                        accordions.forEach(function (acc) {

                                            var accCard = document.createElement('div');
                                            accCard.className = 'card';
                                            accCard.id = 'card-' + acc.replace(/\s+/g, '');
                                            accCard.style.marginBottom = '10px';
                                            var accCardHeader = document.createElement('div');
                                            accCardHeader.className = 'card-header';
                                            var anchorAcc = document.createElement('a');
                                            anchorAcc.className = 'card-link gdpr-card-anchor';
                                            anchorAcc.innerHTML = acc;
                                            anchorAcc.setAttribute('data-toggle', 'collapse');
                                            anchorAcc.setAttribute('data-target', '#collapse-' + acc.replace(/\s+/g, ""));
                                            anchorAcc.setAttribute('href', '#');
                                            accCardHeader.appendChild(anchorAcc);

                                            var accCollapse = document.createElement('div');
                                            accCollapse.id = 'collapse-' + acc.replace(/\s+/g, "");
                                            accCollapse.className = 'collapse';
                                            accCollapse.setAttribute('data-parent', '#accordion');
                                            var accCardBody = document.createElement('div');
                                            accCardBody.id = 'accordion-' + acc.replace(/\s+/g, "");
                                            accCardBody.className = 'card-body';
                                            accCardBody.style.height = acc === 'Terms of Use' ? '200px' : '400px';
                                            accCardBody.style.overflow = 'auto';
                                            accCollapse.appendChild(accCardBody);

                                            accCard.appendChild(accCardHeader);
                                            accCard.appendChild(accCollapse);
                                            accordion.appendChild(accCard);
                                            accordionFragments.appendChild(accordion);

                                            if (acc === 'Cookies') {
                                                var cookieContainer = document.createElement('div');
                                                cookieContainer.className = "container";

                                                var cookieRow = document.createElement('div');
                                                cookieRow.className = "row";

                                                var rowHeader = document.createElement('h6');
                                                rowHeader.className = "policyText";
                                                rowHeader.style.display = 'inline';
                                                rowHeader.innerHTML = "Our website uses cookies and other technologies so that we can remember you and understand how you and other visitors use our site. ";

                                                var cookieAnchorMore = document.createElement('a');
                                                cookieAnchorMore.id = 'cookieAnchorMore';
                                                cookieAnchorMore.innerHTML = '...more';
                                                cookieAnchorMore.setAttribute('href', "#");
                                                cookieAnchorMore.addEventListener('click', function (element) {
                                                    document.getElementById('cookieSpanText').style.display = 'inline';
                                                    document.getElementById('cookieAnchorMore').style.display = 'none';
                                                });

                                                rowHeader.appendChild(cookieAnchorMore);
                                                var cookieSpanText = document.createElement('span');
                                                cookieSpanText.id = 'cookieSpanText';
                                                cookieSpanText.style.display = 'none';

                                                var cookieMoreText = document.createElement('h6');
                                                cookieMoreText.id = 'cookieMoreText';
                                                cookieMoreText.className = 'policyText';
                                                cookieMoreText.innerHTML = "For more information see our\n";

                                                var cookiePolicy = document.createElement('a');
                                                cookiePolicy.className = "consentAnchor";
                                                cookiePolicy.setAttribute("href", appInfo['CookiePolicyURL']);
                                                cookiePolicy.setAttribute("target", "_blank");
                                                cookiePolicy.innerHTML = "Cookie Policy.";

                                                cookieMoreText.appendChild(cookiePolicy);

                                                var anotherDiv = document.createElement('div');
                                                var cookieBothChange = document.createElement('p');
                                                cookieBothChange.id = 'cookieBothChange';
                                                cookieBothChange.className = 'consentDescription';
                                                cookieBothChange.innerHTML = "Our policy has been updated. See yellow highlights for changes.";
                                                $(cookieBothChange).css({
                                                    fontWeight: 'bold',
                                                    display: 'none',
                                                    fontStyle: 'italic'
                                                });
                                                anotherDiv.appendChild(cookieBothChange);

                                                if (appInfo['IsReconsent'] == true) {
                                                    var cookieChange = document.createElement('p');
                                                    cookieChange.id = 'cookieChange';
                                                    cookieChange.className = 'consentDescription';
                                                    cookieChange.appendChild(document.createElement('br'));
                                                    cookieChange.innerHTML = "Our policy has been updated. Please review and re-consent.";
                                                    $(cookieChange).css({
                                                        fontWeight: 'bold',
                                                        fontStyle: 'italic'
                                                    });
                                                    anotherDiv.appendChild(cookieChange);
                                                }

                                                var pCookieTag = document.createElement('p');
                                                pCookieTag.innerHTML = "We want you to control the information we collect, so please indicate your approval for us to collect the below information:";
                                                pCookieTag.style.fontSize = '14px';
                                                pCookieTag.style.lineHeight = '1.2rem';
                                                pCookieTag.style.marginBottom = '0px';
                                                pCookieTag.style.display = 'inline';
                                                cookieRow.appendChild(pCookieTag);

                                                var cookieAnchorLess = document.createElement('a');
                                                cookieAnchorLess.id = 'cookieAnchorLess';
                                                cookieAnchorLess.setAttribute('href', '#');
                                                cookieAnchorLess.innerHTML = '...less';
                                                cookieAnchorLess.style.display = "inline";
                                                cookieAnchorLess.setAttribute('href', "#");
                                                cookieAnchorLess.addEventListener('click', function (element) {
                                                    document.getElementById('cookieSpanText').style.display = 'none';
                                                    document.getElementById('cookieAnchorMore').style.display = 'inline';
                                                });

                                                cookieSpanText.appendChild(cookieMoreText);
                                                cookieSpanText.appendChild(pCookieTag);

                                                cookieSpanText.appendChild(cookieAnchorLess);
                                                cookieRow.appendChild(rowHeader);
                                                cookieRow.appendChild(cookieSpanText);

                                                var cookieTabRow = document.createElement('div');
                                                cookieTabRow.className = "row consentTable";
                                                cookieTabRow.id = "cookieTabDiv";

                                                var cookieTable = document.createElement('table');
                                                cookieTable.id = "cookieTable";
                                                cookieTable.className = "table";

                                                var cookieHead = document.createElement('thead');

                                                var cookieTableRow = document.createElement('tr');

                                                var cookieCellFragment = document.createDocumentFragment();
                                                var cookieTableHeaders = ['Purpose', 'Consent'];

                                                cookieTableHeaders.forEach(function (header) {
                                                    var cell = document.createElement('th');
                                                    cell.textContent = header;
                                                    cookieCellFragment.appendChild(cell);
                                                });

                                                var cookieModalBody = document.createElement('tbody');
                                                cookieModalBody.id = "cookieModalBody";

                                                cookieTableRow.appendChild(cookieCellFragment);
                                                cookieHead.appendChild(cookieTableRow);
                                                cookieTable.appendChild(cookieHead);
                                                cookieTable.appendChild(cookieModalBody);
                                                cookieTabRow.appendChild(cookieTable);
                                                cookieContainer.appendChild(cookieRow);
                                                cookieContainer.appendChild(document.createElement('br'));
                                                cookieContainer.appendChild(cookieTabRow);
                                                accCardBody.appendChild(cookieContainer);
                                            }
                                            if (acc === 'Personal Data') {
                                                var privacyContainer = document.createElement('div');
                                                privacyContainer.className = "container";

                                                var privacyRow = document.createElement('div');
                                                privacyRow.className = "row";

                                                var rowPrivacyHeader = document.createElement('h6');
                                                rowPrivacyHeader.className = "policyText";
                                                rowPrivacyHeader.style.display = 'inline';
                                                rowPrivacyHeader.innerHTML = "At various times Freeman or its agents may collect personally identifiable information. ";

                                                var privacyAnchorMore = document.createElement('a');
                                                privacyAnchorMore.id = 'privacyAnchorMore';
                                                privacyAnchorMore.innerHTML = '...more';
                                                privacyAnchorMore.setAttribute('href', '#');
                                                privacyAnchorMore.addEventListener('click', function (element) {
                                                    document.getElementById('privacySpanText').style.display = 'inline';
                                                    document.getElementById('privacyAnchorMore').style.display = 'none';
                                                });
                                                rowPrivacyHeader.appendChild(privacyAnchorMore);

                                                var privacySpanText = document.createElement('span');
                                                privacySpanText.id = 'privacySpanText';
                                                privacySpanText.style.display = 'none';

                                                var privacyMoreText = document.createElement('h6');
                                                privacyMoreText.id = 'privacyMoreText';
                                                privacyMoreText.className = 'policyText';
                                                privacyMoreText.innerHTML = " Freeman will use your personally identifiable information to perform the services you have contracted from us, where necessary for our legitimate interests (that are not overridden by your fundamental rights), to comply with a legal or regulatory obligation and as further detailed in each Freeman application. For more specifics on our data handling, please see our\n";

                                                var privacyPolicy = document.createElement('a');
                                                privacyPolicy.setAttribute("href", appInfo['PrivacyPolicyURL']);
                                                privacyPolicy.setAttribute("target", "_blank");
                                                privacyPolicy.innerHTML = " Privacy Policy.";
                                                privacyPolicy.className = "consentAnchor";

                                                privacyMoreText.appendChild(privacyPolicy);
                                                var pPrivacyTag = document.createElement('p');
                                                pPrivacyTag.innerHTML = "We want you to control the information we collect, so please indicate your approval for us to collect the below information:";
                                                pPrivacyTag.style.fontSize = '14px';
                                                pPrivacyTag.style.lineHeight = '1.2rem';
                                                pPrivacyTag.style.marginBottom = '0px';
                                                pPrivacyTag.style.display = 'inline';
                                                privacyRow.appendChild(pPrivacyTag);


                                                var privacyAnchorLess = document.createElement('a');
                                                privacyAnchorLess.id = 'privacyAnchorLess';
                                                privacyAnchorLess.setAttribute('href', '#');
                                                privacyAnchorLess.innerHTML = '...less';
                                                privacyAnchorLess.style.display = "inline";
                                                privacyAnchorLess.setAttribute('href', "#");
                                                privacyAnchorLess.addEventListener('click', function (element) {
                                                    document.getElementById('privacySpanText').style.display = 'none';
                                                    document.getElementById('privacyAnchorMore').style.display = 'inline';
                                                });

                                                privacySpanText.appendChild(privacyMoreText);
                                                var privacyBothChange = document.createElement('p');
                                                privacyBothChange.id = 'privacyBothChange';
                                                privacyBothChange.className = 'consentDescription';
                                                privacyBothChange.innerHTML = "Our policy has been updated. See yellow highlights for changes.";
                                                $(privacyBothChange).css({
                                                    fontWeight: 'bold',
                                                    display: 'none',
                                                    fontStyle: 'italic'
                                                });
                                                privacySpanText.appendChild(privacyBothChange);
                                                if (appInfo['IsReconsent'] == true) {
                                                    var privacyChange = document.createElement('p');
                                                    privacyChange.id = 'privacyChange';
                                                    privacyChange.className = 'consentDescription';
                                                    privacyChange.innerHTML = "Our policy has been updated. Please review and re-consent.";
                                                    $(privacyChange).css({
                                                        fontWeight: 'bold',
                                                        fontStyle: 'italic'
                                                    });
                                                    privacySpanText.appendChild(privacyChange);
                                                }
                                                privacySpanText.appendChild(pPrivacyTag);
                                                privacySpanText.appendChild(privacyAnchorLess);
                                                privacyRow.appendChild(rowPrivacyHeader);
                                                privacyRow.appendChild(privacySpanText);

                                                var privacyTabRow = document.createElement('div');
                                                privacyTabRow.className = "row consentTable";
                                                privacyTabRow.id = "privacyTabDiv";

                                                var privacyTable = document.createElement('table');
                                                privacyTable.id = "privacyTable";
                                                privacyTable.className = "table";

                                                var privacyHead = document.createElement('thead');

                                                var privacyTableRow = document.createElement('tr');

                                                var privacyCellFragment = document.createDocumentFragment();
                                                var privacyTableHeaders = ['How we use this data', 'Consent'];

                                                privacyTableHeaders.forEach(function (header) {
                                                    var cell = document.createElement('th');
                                                    cell.textContent = header;
                                                    privacyCellFragment.appendChild(cell);
                                                });

                                                privacyTableRow.appendChild(privacyCellFragment);

                                                var privacyModalBody = document.createElement('tbody');
                                                privacyModalBody.id = "privacyModalBody";

                                                privacyHead.appendChild(privacyTableRow);
                                                privacyTable.appendChild(privacyHead);
                                                privacyTable.appendChild(privacyModalBody);
                                                privacyTabRow.appendChild(privacyTable);
                                                privacyContainer.appendChild(privacyRow);
                                                privacyContainer.appendChild(document.createElement('br'));
                                                privacyContainer.appendChild(privacyTabRow);
                                                accCardBody.appendChild(privacyContainer);
                                            }
                                            if (acc === 'Terms of Use') {
                                                var termsContainer = document.createElement('div');
                                                termsContainer.className = "container";

                                                var termsAction = document.createElement('div');
                                                termsAction.className = 'row';

                                                var termsHeader = document.createElement('h6');
                                                termsHeader.innerHTML = "Click ";
                                                termsHeader.className = "policyText";

                                                var TPolicy = document.createElement('a');
                                                TPolicy.id = "aSpan";
                                                TPolicy.setAttribute("href", appInfo['TermsConditionsURL']);
                                                TPolicy.setAttribute("target", "_blank");
                                                TPolicy.innerHTML = "here";
                                                TPolicy.className = "consentAnchor";

                                                var tSpan = document.createElement('span');
                                                tSpan.innerHTML = " to read our Terms of Use.";

                                                termsHeader.appendChild(TPolicy);
                                                termsHeader.appendChild(tSpan);
                                                termsAction.appendChild(termsHeader);

                                                termsRow.className = "row";


                                                var termslabel = document.createElement('label');
                                                var termstext = document.createTextNode(' I have read and agreed to the Terms of Use, Privacy Policy and Cookie Policy.');
                                                var termsbox = document.createElement('input');
                                                termsbox.type = "checkbox";
                                                termsbox.id = "termsbox";
                                                termsbox.className = "consentCheckbox";
                                                termsbox.addEventListener('click', function (element) {
                                                    if ($('#termsbox').is(":checked")) {
                                                        $('#continueButton').removeClass("disabled bg-disabled").attr("rel", null);
                                                        $('#continueButton').addClass("btn-primary btn-primary-color").attr("rel", null);
                                                    } else if (!$('#termsbox').is(":checked")) {
                                                        $('#continueButton').removeClass("btn-primary btn-primary-color").attr("rel", null);
                                                        $('#continueButton').addClass("disabled bg-disabled").attr("rel", "tooltip");
                                                    }
                                                });

                                                termslabel.appendChild(termsbox);
                                                termslabel.appendChild(termstext);
                                                termsRow.appendChild(termslabel);
                                                termsContainer.appendChild(termsHeader);
                                                termsContainer.appendChild(termsAction);
                                                termsContainer.appendChild(termsRow);
                                                accCardBody.appendChild(termsContainer);
                                            }
                                        });
                                        accordionGroup.appendChild(accordionFragments);

                                        modalBody.appendChild(accordionGroup);

                                        var modalFooter = document.createElement('div');
                                        modalFooter.className = "modal-footer";

                                        var footerContainer = document.createElement('div');
                                        footerContainer.className = "container";

                                        var btnRow1 = document.createElement('div');
                                        btnRow1.className = "row";

                                        var column1 = document.createElement('div');
                                        column1.className = "col-7 col-md-9";

                                        var column2 = document.createElement("div");
                                        column2.className = "col-4 col-md-2";

                                        var continueButton = document.createElement('button');
                                        continueButton.id = "continueButton";
                                        continueButton.type = "button";
                                        continueButton.innerHTML = "Continue";
                                        continueButton.className = "btn disabled bg-disabled";
                                        continueButton.setAttribute("data-title", "Please agree to Terms of use to continue");
                                        continueButton.addEventListener('click', function (element) {
                                            onContinueClick(cookiesData, pInfoData, appinfo);
                                        });

                                        column2.appendChild(continueButton);
                                        btnRow1.appendChild(column1);
                                        btnRow1.appendChild(column2);

                                        footerContainer.appendChild(btnRow1);
                                        modalFooter.appendChild(footerContainer);

                                    }



                                    modalContent.appendChild(modalHeader);
                                    modalContent.appendChild(modalBody);
                                    modalContent.appendChild(modalFooter);
                                    modalDialog.appendChild(modalContent);
                                    combinedModal.appendChild(modalDialog);

                                    $(combinedStyles).appendTo('head');
                                    document.body.appendChild(combinedModal);
                                    $('#combinedModal').modal('show');

                                    var getAppCookies = appEnv + "/cookieconsent/APP_NAME"
                                        .replace(/APP_NAME/g, appData['appName']);

                                    var getPiiData = appEnv + "/piiconsent/APP_NAME"
                                        .replace(/APP_NAME/g, appData['appName']);

                                    $.get(getAppCookies, function (data) {
                                        cookiesData = data;
                                        if (windowWidth >= 1024) {
                                            $(this).addCookieDataWeb(appData, cookiesData);
                                        } else {
                                            $(this).addCookieData(appData, cookiesData, windowWidth);
                                        }
                                    });

                                    $.get(getPiiData, function (data) {
                                        pInfoData = data;
                                        var piiEmailConsent = false;
                                        var piiEmailRequired = false;
                                        var userConsentedEmail = false;
                                        var UserPIIFieldsObj = pInfoData.filter(function (el) {
                                            return el.FieldName == "Email";
                                        });
                                        if (UserPIIFieldsObj.length != 0) {
                                            userConsentedEmail = true;
                                            if (UserPIIFieldsObj[0].IsRequired == true) {
                                                piiEmailRequired = true;
                                                piiEmailConsent = true;
                                            } else {
                                                piiEmailRequired = false;
                                                piiEmailConsent = false;
                                            }
                                        } else {
                                            userConsentedEmail = false;
                                        }

                                        if (appInfo.IsMarketingData == true && userConsentedEmail == true) {
                                            promotionsCheckbox.type = "checkbox";
                                            promotionsCheckbox.name = "promotions";
                                            promotionsCheckbox.style.display = "inline";
                                            promotionsCheckbox.id = "promotionsChkbox";
                                            promotionsCheckbox.className = "consentCheckbox";

                                            var promotionslabeltext = document.createTextNode(' Please keep me updated with Freeman news and promotions.');

                                            promotionsCheckboxChkboxLabel.appendChild(promotionsCheckbox);
                                            promotionsCheckboxChkboxLabel.appendChild(promotionslabeltext);
                                            promotionsCheckboxChkboxLabel.className = "font-weight";
                                            if (piiEmailRequired == true) {
                                                promotionsCheckbox.checked = false;
                                                promotionsCheckboxChkboxLabel.className = "font-weight";
                                            } else {
                                                if (piiEmailConsent == true) {
                                                    promotionsCheckbox.checked = true;
                                                } else {
                                                    promotionsCheckbox.checked = false;
                                                    // promotionsCheckboxChkboxLabel.className = "font-weight checkBox-disabled";
                                                    promotionsCheckbox.style.display = 'none';
                                                    promotionsCheckboxChkboxLabel.style.display = 'none';
                                                }
                                            }
                                            setTimeout(function () {
                                                if (windowWidth < 1024) {
                                                    column1.appendChild(promotionsCheckboxChkboxLabel);
                                                }
                                            }, 100);
                                        }

                                        setTimeout(function () {
                                            if (emailID != undefined) {
                                                document.getElementById(emailID).addEventListener("click", function () {
                                                    if ($('#' + emailID).is(":checked")) {
                                                        promotionsCheckbox.style.display = 'inline';
                                                        promotionsCheckboxChkboxLabel.style.display = 'inline';
                                                    } else {
                                                        promotionsCheckbox.style.display = 'none';
                                                        promotionsCheckboxChkboxLabel.style.display = 'none';
                                                    }
                                                });
                                            }
                                        }, 100);
                                        if (windowWidth >= 1024) {
                                            $(this).addPrivacyDataWeb(appData, pInfoData);
                                        } else {
                                            $(this).addPrivacyData(appData, pInfoData);
                                        }
                                    });

                                    $('body').tooltip({
                                        selector: '[rel="tooltip"]'
                                    });

                                } else {
                                    usrData.UserPIIFields = usrPii['UserPIIFields'];
                                    usrData.Token = combinedToken;
                                    callback(usrData);
                                }
                            });
                        });
                    })
                });
            });
        },
        addCookieDataWeb: function (appData, cookiesData) {
            $('#cookieModalBody').find('tr').remove();
            var cookiesBody = document.getElementById('cookieModalBody');

            for (var i = 0; i < cookiesData.length; i++) {
                for (var j = 0; j < cookiesData[i].length; j++) {
                    var tr = document.createElement("TR");
                    tr.id = "tr-" + i + "" + j;

                    var rowFragment = document.createDocumentFragment();
                    var current = cookiesData[i][j];
                    var titles = ['Name', 'Category', 'CookieConsentId'];
                    titles.forEach(function (title) {
                        var td = document.createElement('td');
                        if (current['IsReconsent'] === true) {
                            $(td).css({
                                backgroundColor: '#fcfb41',
                                color: "#9a9997"
                            });

                            if (document.getElementById('cookieBothChange')) {
                                document.getElementById('cookieBothChange').style.display = 'inline-block';
                            }
                            if (document.getElementById('cookieChange')) {
                                document.getElementById('cookieChange').style.display = 'none';
                            }
                        } else {
                            $(td).css({
                                color: "#9a9997"
                            })
                        }
                        if (title === 'CookieConsentId') {
                            $(td).css({
                                width: "95px"
                            });
                            var switchCookieLabel = document.createElement("label");
                            switchCookieLabel.className = "switch";
                            var cookieCheckbox = document.createElement("input");
                            cookieCheckbox.type = "checkbox";
                            cookieCheckbox.checked = !current['IsActionable'];
                            cookieCheckbox.id = "cookieCheckbox-" + (i + j);
                            cookieCheckbox.disabled = cookieCheckbox.checked;
                            cookieCheckbox.className = cookieCheckbox.checked ? "disabled" : "";
                            var sliderCookieSpan = document.createElement('span');
                            if (cookieCheckbox.checked === true) {
                                sliderCookieSpan.innerText = "On";
                                sliderCookieSpan.className = "slider round disabledColor onSpan";
                            } else {
                                sliderCookieSpan.innerText = "Off";
                                sliderCookieSpan.className = "slider round bg-white offspan";
                            }
                            cookieCheckbox.onclick = function () {
                                if (cookieCheckbox.checked === true) {
                                    sliderCookieSpan.innerText = "On";
                                    sliderCookieSpan.className = "slider round onSpan";
                                } else {
                                    sliderCookieSpan.innerText = "Off";
                                    sliderCookieSpan.className = "bg-white slider round offspan";
                                }
                            };
                            switchCookieLabel.appendChild(cookieCheckbox);
                            switchCookieLabel.appendChild(sliderCookieSpan);
                            td.textContent = "";
                            td.appendChild(switchCookieLabel);
                        }
                        var IsRequiredCookie = document.createElement('p');
                        var cookieCategory = document.createElement('p');
                        if (title === 'Name') {
                            $(td).css({
                                width: "175px"
                            });
                            td.innerHTML = current[title];
                            td.className = "cookie-Name";
                            IsRequiredCookie.className = "font-13";
                            if (!current['IsActionable']) {
                                IsRequiredCookie.innerText = "(Required)";
                            } else {
                                IsRequiredCookie.innerText = "(Optional)";
                            }
                            cookieCategory.innerText = current['Category']['Category'];
                            cookieCategory.className = "mar-bottom-0 font-15"
                            td.appendChild(cookieCategory);
                            td.appendChild(IsRequiredCookie);
                        }
                        var categoryDesc = document.createElement('p');
                        if (title === 'Category') {

                            categoryDesc.innerHTML = current[title]['Description'];
                            categoryDesc.className = "categoryTextWeb more";
                            td.textContent = '';
                            td.appendChild(categoryDesc);
                        }
                        rowFragment.appendChild(td);
                    });
                    tr.appendChild(rowFragment);
                    cookiesBody.appendChild(tr);
                }
            }
        },

        addCookieData: function (appData, cookiesData, width, options) {
            $('#cookieModalBody').find('tr').remove();
            var cookiesBody = document.getElementById('cookieModalBody');

            for (var i = 0; i < cookiesData.length; i++) {
                for (var j = 0; j < cookiesData[i].length; j++) {
                    var tr = document.createElement("TR");
                    tr.id = "tr-" + i + "" + j;

                    var rowFragment = document.createDocumentFragment();
                    var current = cookiesData[i][j];
                    var titles = ['Name', 'CookieConsentId'];
                    titles.forEach(function (title) {
                        var td = document.createElement('td');
                        td.textContent = title !== 'IsActionable' ? current[title] : (!current[title] ? 'Required' : 'Optional');
                        if (current['IsReconsent'] === true) {
                            $(td).css({
                                backgroundColor: '#fcfb41'
                            });

                            if (document.getElementById('cookieBothChange')) {
                                document.getElementById('cookieBothChange').style.display = 'inline-block';
                            }
                            if (document.getElementById('cookieChange')) {
                                document.getElementById('cookieChange').style.display = 'none';
                            }
                        }
                        var categoryDesc = document.createElement('p');
                        if (title === 'Name') {
                            $(td).css({
                                width: "400px"
                            });
                            var stringParts = (current['Text'].match(/.{1,65}/g)) || [];

                            if (stringParts.length > 1) {
                                categoryDesc.className = "categoryText";
                                var moreDesc = document.createElement('a');
                                moreDesc.id = 'moreDesc-' + current['CookieConsentId'];
                                moreDesc.setAttribute('href', '#');
                                moreDesc.innerHTML = '...more';
                                moreDesc.addEventListener('click', function (element) {
                                    document.getElementById('showDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'inline';
                                    document.getElementById('moreDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'none';
                                });

                                var newText = '';
                                for (var m = 1; m < stringParts.length; m++) {
                                    newText = newText + stringParts[m];
                                }

                                var remText = document.createElement('p');
                                remText.id = 'showDesc-' + current['CookieConsentId'];
                                remText.textContent = newText;
                                remText.style.wordBreak = 'break-word';
                                var lessDesc = document.createElement('a');
                                lessDesc.setAttribute('href', '#');
                                lessDesc.innerHTML = '...less';
                                lessDesc.id = 'lessDesc-' + current['CookieConsentId'];
                                lessDesc.addEventListener('click', function (element) {
                                    document.getElementById('showDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'none';
                                    document.getElementById('moreDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'inline';
                                });
                                remText.appendChild(lessDesc);
                                remText.style.display = 'none';
                                categoryDesc.innerHTML = stringParts[0];
                                categoryDesc.style.wordBreak = 'break-word';
                                categoryDesc.appendChild(moreDesc);
                                categoryDesc.appendChild(remText);
                                td.appendChild(categoryDesc);
                            } else {
                                categoryDesc.className = "categoryText";
                                categoryDesc.innerHTML = stringParts[0];
                                categoryDesc.style.wordBreak = 'break-word';
                                td.appendChild(categoryDesc);
                            }
                        }

                        if (title === 'CookieConsentId') {
                            var switchCookieLabel = document.createElement("label");
                            switchCookieLabel.className = "switch";
                            var cookieCheckbox = document.createElement("input");
                            cookieCheckbox.type = "checkbox";
                            cookieCheckbox.checked = !current['IsActionable'];
                            cookieCheckbox.id = "cookieCheckbox-" + (i + j);
                            cookieCheckbox.disabled = cookieCheckbox.checked;
                            cookieCheckbox.className = cookieCheckbox.checked ? "disabled" : "";
                            var sliderCookieSpan = document.createElement('span');
                            if (cookieCheckbox.checked === true) {
                                sliderCookieSpan.innerText = "On";
                                sliderCookieSpan.className = "slider round disabledColor onSpan";
                            } else {
                                sliderCookieSpan.innerText = "Off";
                                sliderCookieSpan.className = "bg-white slider round";
                            }
                            cookieCheckbox.onclick = function () {
                                if (cookieCheckbox.checked === true) {
                                    sliderCookieSpan.innerText = "On";
                                    sliderCookieSpan.className = "slider round onSpan";
                                } else {
                                    sliderCookieSpan.innerText = "Off";
                                    sliderCookieSpan.className = "bg-white slider round";
                                }
                            };
                            switchCookieLabel.appendChild(cookieCheckbox);
                            switchCookieLabel.appendChild(sliderCookieSpan);
                            td.textContent = "";
                            td.appendChild(switchCookieLabel);
                        }
                        rowFragment.appendChild(td);
                    });
                    tr.appendChild(rowFragment);
                    cookiesBody.appendChild(tr);
                }
            }
        },

        addPrivacyDataWeb: function (appData, privacyData) {
            $('#privacyModalBody').find('tr').remove();
            var tbody = document.getElementById('privacyModalBody');
            for (var i = 0; i < privacyData.length; i++) {
                var tr = document.createElement('TR');
                tr.id = 'tr-' + privacyData[i]['PIIConsentId'];

                var rowFragment = document.createDocumentFragment();
                var current = privacyData[i];
                var titles = ['FieldName', 'Text', 'PIIConsentId'];
                titles.forEach(function (title) {
                    var td = document.createElement('td');
                    var currentSpan = document.createElement('span');
                    currentSpan.id = 'currentSpan-' + privacyData[i]['PIIConsentId'];
                    currentSpan.innerHTML = title !== 'IsRequired' ? current[title] : (current[title] ? 'Required' : 'Optional');
                    td.appendChild(currentSpan);
                    if (current['IsReconsent'] === true) {
                        $(td).css({
                            backgroundColor: '#fcfb41',
                            color: "#9a9997"
                        });

                        if (document.getElementById('privacyBothChange')) {
                            document.getElementById('privacyBothChange').style.display = 'inline';
                        }
                        if (document.getElementById('privacyChange')) {
                            document.getElementById('privacyChange').style.display = 'none';
                        }
                    } else {
                        $(td).css({
                            color: "#9a9997"
                        })
                    }
                    if (title === 'Text') {
                        td.className = "categoryTextWeb more";
                    }
                    var IsRequiredPrivacy = document.createElement('p');
                    if (title === 'FieldName') {
                        $(td).css({
                            width: "150px"
                        });
                        td.innerHTML = current[title];
                        td.className = "cookie-Name";
                        IsRequiredPrivacy.className = "font-13";
                        if (!!privacyData[i]['IsRequired']) {
                            IsRequiredPrivacy.innerText = "(Required)";
                        } else {
                            IsRequiredPrivacy.innerText = "(Optional)";
                        }
                        td.appendChild(IsRequiredPrivacy);
                    }
                    if (title === 'PIIConsentId') {
                        $(td).css({
                            width: "95px"
                        });
                        var switchLabel = document.createElement("label");
                        switchLabel.className = "switch";
                        var checkbox = document.createElement("input");
                        checkbox.type = "checkbox";
                        checkbox.checked = !!privacyData[i]['IsRequired'];
                        checkbox.id = "privacyCheckbox-" + (i);
                        if (privacyData[i]['FieldName'] == "Email") {
                            emailID = checkbox.id;
                        }
                        checkbox.disabled = checkbox.checked;
                        checkbox.className = checkbox.checked ? "disabled" : "";
                        var sliderSpan = document.createElement('span');
                        if (checkbox.checked === true) {
                            sliderSpan.innerText = "On";
                            sliderSpan.className = "slider round disabledColor onSpan";
                        } else {
                            sliderSpan.innerText = "Off";
                            sliderSpan.className = "bg-white slider round";
                        }
                        checkbox.onclick = function () {
                            if (checkbox.checked === true) {
                                sliderSpan.innerText = "On";
                                sliderSpan.className = "slider round onSpan";
                            } else {
                                sliderSpan.innerText = "Off";
                                sliderSpan.className = "bg-white slider round";
                            }
                        };
                        switchLabel.appendChild(checkbox);
                        switchLabel.appendChild(sliderSpan);

                        td.textContent = '';
                        td.appendChild(switchLabel);
                    }
                    rowFragment.appendChild(td);
                });
                tr.appendChild(rowFragment);
                tbody.appendChild(tr);
            }
        },
        addPrivacyData: function (appData, privacyData, width, options) {
            $('#privacyModalBody').find('tr').remove();
            var tbody = document.getElementById('privacyModalBody');
            for (var i = 0; i < privacyData.length; i++) {
                var tr = document.createElement('TR');
                tr.id = 'tr-' + privacyData[i]['PIIConsentId'];

                var rowFragment = document.createDocumentFragment();
                var current = privacyData[i];
                var titles = ['FieldName', 'PIIConsentId'];
                titles.forEach(function (title) {
                    var td = document.createElement('td');
                    var currentSpan = document.createElement('span');
                    currentSpan.id = 'currentSpan-' + privacyData[i]['PIIConsentId'];
                    currentSpan.innerHTML = title !== 'IsRequired' ? current[title] : (current[title] ? 'Required' : 'Optional');
                    td.appendChild(currentSpan);
                    if (current['IsReconsent'] === true) {
                        $(td).css({
                            backgroundColor: '#fcfb41'
                        });

                        if (document.getElementById('privacyBothChange')) {
                            document.getElementById('privacyBothChange').style.display = 'inline';
                        }
                        if (document.getElementById('privacyChange')) {
                            document.getElementById('privacyChange').style.display = 'none';
                        }
                    }
                    var description = document.createElement('p');
                    if (width < 1024) {
                        if (title === 'FieldName') {
                            $(td).css({
                                width: '400px'
                            });
                            var stringParts = (current['Text'].match(/.{1,65}/g)) || [];
                            if (stringParts.length > 1) {
                                description.className = 'categoryText';
                                var moreDesc = document.createElement('a');
                                moreDesc.id = 'moreDesc-' + current['PIIConsentId'];
                                moreDesc.setAttribute('href', '#');
                                moreDesc.innerHTML = '...more';
                                moreDesc.addEventListener('click', function (element) {
                                    document.getElementById('showDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'inline';
                                    document.getElementById('moreDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'none';
                                });

                                var newText = '';
                                for (var m = 1; m < stringParts.length; m++) {
                                    newText = newText + stringParts[m];
                                }

                                var remText = document.createElement('p');
                                remText.id = 'showDesc-' + current['PIIConsentId'];
                                remText.textContent = newText;
                                remText.style.wordBreak = 'break-word';
                                var lessDesc = document.createElement('a');
                                lessDesc.setAttribute('href', '#');
                                lessDesc.innerHTML = '...less';
                                lessDesc.id = 'lessDesc-' + current['PIIConsentId'];
                                lessDesc.addEventListener('click', function (element) {
                                    document.getElementById('showDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'none';
                                    document.getElementById('moreDesc-' + (element['currentTarget']['id'].split('-'))[1]).style.display = 'inline';
                                });
                                remText.appendChild(lessDesc);
                                remText.style.display = 'none';
                                description.innerHTML = stringParts[0];
                                description.style.wordBreak = 'break-word';
                                description.style.fontStyle = 'italic';
                                description.appendChild(moreDesc);
                                description.appendChild(remText);
                                td.appendChild(description);
                            } else {
                                description.className = 'categoryText';
                                description.innerHTML = stringParts[0];
                                description.style.wordBreak = 'break-word';
                                description.style.fontStyle = 'italic';
                                td.appendChild(description);
                            }
                        }
                    }

                    if (title === 'PIIConsentId') {
                        var switchLabel = document.createElement("label");
                        switchLabel.className = "switch";
                        var checkbox = document.createElement("input");
                        checkbox.type = "checkbox";
                        checkbox.checked = !!privacyData[i]['IsRequired'];
                        checkbox.id = "privacyCheckbox-" + (i);
                        if (privacyData[i]['FieldName'] == "Email") {
                            emailID = checkbox.id;
                        }
                        checkbox.disabled = checkbox.checked;
                        checkbox.className = checkbox.checked ? "disabled" : "";
                        var sliderSpan = document.createElement('span');
                        if (checkbox.checked === true) {
                            sliderSpan.innerText = "On";
                            sliderSpan.className = "slider round disabledColor onSpan";
                        } else {
                            sliderSpan.innerText = "Off";
                            sliderSpan.className = "slider round bg-white";
                        }
                        checkbox.onclick = function () {
                            if (checkbox.checked === true) {
                                sliderSpan.innerText = "On";
                                sliderSpan.className = "slider round onSpan";
                            } else {
                                sliderSpan.innerText = "Off";
                                sliderSpan.className = "slider round bg-white";
                            }
                        };
                        switchLabel.appendChild(checkbox);
                        switchLabel.appendChild(sliderSpan);

                        td.textContent = '';
                        td.appendChild(switchLabel);
                    }
                    rowFragment.appendChild(td);
                });
                tr.appendChild(rowFragment);
                tbody.appendChild(tr);
            }
        },

        getToken: function (application, cEnv, callback) {

            var cTokenObject = {
                Application: application.appName,
                Username: application.userName,
                ApiKey: application.appKey
            };

            $.post(cEnv + "/utility/gettoken", cTokenObject, function (data, status, xhr) {
                callback(data['Token']);
            });
        }
    })
})(jQuery, window, document);